This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Integrate mainline
[perl5.git] / ext / util / make_ext
CommitLineData
75f92628
AD
1#!/bin/sh
2
a0d0e21e
LW
3# This script acts as a simple interface for building extensions.
4# It primarily used by the perl Makefile:
5#
6# d_dummy $(dynamic_ext): miniperl preplibrary FORCE
fb73857a 7# @sh ext/util/make_ext dynamic $@ MAKE=$(MAKE) LIBPERL_A=$(LIBPERL)
a0d0e21e
LW
8#
9# It may be deleted in a later release of perl so try to
10# avoid using it for other purposes.
11
42793c05
TB
12target=$1; shift
13extspec=$1; shift
fb73857a 14makecmd=$1; shift # Should be something like MAKE=make
42793c05
TB
15passthru="$*" # allow extra macro=value to be passed through
16echo ""
a0d0e21e 17
fb73857a 18# Previously, $make was taken from config.sh. However, the user might
19# instead be running a possibly incompatible make. This might happen if
20# the user types "gmake" instead of a plain "make", for example. The
21# correct current value of MAKE will come through from the main perl
22# makefile as MAKE=/whatever/make in $makecmd. We'll be cautious in
23# case third party users of this script (are there any?) don't have the
24# MAKE=$(MAKE) argument, which was added after 5.004_03.
25case "$makecmd" in
26MAKE=*)
27 eval $makecmd
28 ;;
29*) echo 'ext/util/make_ext: WARNING: Please include MAKE=$(MAKE)'
30 echo ' in your call to make_ext. See ext/util/make_ext for details.'
31 exit 1
32 ;;
33esac
34
35
a0d0e21e
LW
36case $CONFIG in
37'')
38 if test -f config.sh; then TOP=.;
39 elif test -f ../config.sh; then TOP=..;
40 elif test -f ../../config.sh; then TOP=../..;
41 elif test -f ../../../config.sh; then TOP=../../..;
42 elif test -f ../../../../config.sh; then TOP=../../../..;
43 else
44 echo "Can't find config.sh generated by Configure"; exit 1
45 fi
46 . $TOP/config.sh
47 ;;
48esac
49
50if test "X$extspec" = X; then
51 echo "make_ext: no extension specified"
52 exit 1;
53fi
54
75f92628 55# The Perl Makefile.SH will expand all extensions to
2698564b 56# lib/auto/X/X.a (or lib/auto/X/Y/Y.a if nested)
75f92628 57# A user wishing to run make_ext might use
2698564b 58# X (or X/Y or X::Y if nested)
75f92628
AD
59
60# canonise into X/Y form (pname)
61case "$extspec" in
62lib*) # Remove lib/auto prefix and /*.* suffix
63 pname=`echo "$extspec" | sed -e 's:^lib/auto/::' -e 's:/[^/]*\.[^/]*$::' ` ;;
4318d5a0
GB
64ext*) # Remove ext/ prefix and /pm_to_blib suffix
65 pname=`echo "$extspec" | sed -e 's:^ext/::' -e 's:/pm_to_blib$::' ` ;;
75f92628
AD
66*::*) # Convert :: to /
67 pname=`echo "$extspec" | sed -e 's/::/\//g' ` ;;
68*) pname="$extspec" ;;
69esac
70# echo "Converted $extspec to $pname"
a0d0e21e 71
e1666bf5 72mname=`echo "$pname" | sed -e 's!/!::!g'`
a0d0e21e 73depth=`echo "$pname" | sed -e 's![^/][^/]*!..!g'`
75f92628 74makefile=Makefile
42793c05 75makeargs=''
75f92628 76makeopts=''
a0d0e21e 77
3b5ca523 78if test ! -d "ext/$pname"; then
42793c05
TB
79 echo " Skipping $extspec (directory does not exist)"
80 exit 0 # not an error ?
a0d0e21e
LW
81fi
82
a0d0e21e 83
42793c05 84echo " Making $mname ($target)"
a0d0e21e
LW
85
86cd ext/$pname
87
42793c05
TB
88# check link type and do any preliminaries
89case "$target" in
75f92628
AD
90 # convert 'static' or 'dynamic' into 'all LINKTYPE=XXX'
91static) makeargs="LINKTYPE=static CCCDLFLAGS="
92 target=all
93 ;;
94dynamic) makeargs="LINKTYPE=dynamic";
95 target=all
96 ;;
97
4318d5a0
GB
98nonxs) makeargs="";
99 target=all
100 ;;
101
75f92628
AD
102*clean) # If Makefile has been moved to Makefile.old by a make clean
103 # then use Makefile.old for realclean rather than rebuild it
104 if test ! -f $makefile -a -f Makefile.old; then
105 makefile=Makefile.old
106 makeopts="-f $makefile"
107 echo "Note: Using Makefile.old"
108 fi
109 ;;
110
42793c05 111*) # for the time being we are strict about what make_ext is used for
75f92628
AD
112 echo "make_ext: unknown make target '$target'"; exit 1
113 ;;
114'') echo "make_ext: no make target specified (eg static or dynamic)"; exit 1
115 ;;
42793c05
TB
116esac
117
75f92628 118if test ! -f $makefile ; then
afd1eb53 119 test -f Makefile.PL && ../$depth/miniperl -I../$depth/lib Makefile.PL INSTALLDIRS=perl PERL_CORE=1 $passthru
a0d0e21e 120fi
75f92628
AD
121if test ! -f $makefile ; then
122 if test -f Makefile.SH; then
123 echo "Warning: Writing $makefile from old-style Makefile.SH!"
124 sh Makefile.SH
125 else
126 echo "Warning: No Makefile!"
127 fi
a0d0e21e
LW
128fi
129
42793c05
TB
130case "$target" in
131clean) ;;
132realclean) ;;
75f92628
AD
133*) # Give makefile an opportunity to rewrite itself.
134 # reassure users that life goes on...
fb73857a 135 $MAKE config $passthru || echo "$MAKE config failed, continuing anyway..."
75f92628 136 ;;
42793c05 137esac
a0d0e21e 138
fb73857a 139$MAKE $makeopts $target $makeargs $passthru || exit
a0d0e21e
LW
140
141exit $?